#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), remove when upstream will support it
%ifnarch %{ix86} %{x8664} arm aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%if %{without ocaml_opt}
%define		_enable_debug_packages	0
%endif

%define		pkgname	extlib
%define		ocaml_ver	1:3.09.2
Summary:	ExtLib for OCaml
Summary(pl.UTF-8):	ExtLib dla OCamla
Name:		ocaml-%{pkgname}
Version:	1.7.8
Release:	3
License:	LGPL + OCaml linking exception
Group:		Libraries
Source0:	https://github.com/ygrek/ocaml-extlib/releases/download/%{version}/extlib-%{version}.tar.gz
# Source0-md5:	7e0df072af4e2daa094e5936a661cb11
Patch0:		no-git.patch
URL:		https://github.com/ygrek/ocaml-extlib
BuildRequires:	cppo
BuildRequires:	ocaml >= %{ocaml_ver}
BuildRequires:	ocaml-findlib-devel
%requires_eq	ocaml-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
ExtLib is a project aiming at providing a complete - yet small -
standard library for the OCaml programming language. The purpose of
this library is to add new functions to OCaml Standard Library
modules, to modify some functions in order to get better performances
or more safety (tail-recursive) but also to provide new modules which
should be useful for the average OCaml programmer.

ExtLib is not directly related to OCaml authors (INRIA) although this
library can be seen as a proposal for inclusion in the official
distribution.

%description -l pl.UTF-8
ExtLib to projekt, którego celem jest dostarczenie kompletnej lecz
małej biblioteki standardowej dla języka programowania OCaml. Celem
tej biblioteki jest dodanie nowych funkcji do modułów biblioteki
standardowej OCamla, zmodyfikowanie niektórych funkcji w celu
uzyskania lepszej wydajności lub bezpieczeństwa, a także dodanie
nowych modułów, które powinny być przydatne dla przeciętnego
programisty OCamla.

ExtLib nie jest bezpośrednio związany z autorami OCamla (INRIA), ale
tę bibliotekę można traktować jako propozycję do włączenia do
oficjalnej dystrybucji.

%package devel
Summary:	ExtLib for OCaml - development part
Summary(pl.UTF-8):	ExtLib dla OCamla - część programistyczna
Group:		Development/Libraries
%requires_eq	ocaml

%description devel
ExtLib is a project aiming at providing a complete - yet small -
standard library for the OCaml programming language. The purpose of
this library is to add new functions to OCaml Standard Library
modules, to modify some functions in order to get better performances
or more safety (tail-recursive) but also to provide new modules which
should be useful for the average OCaml programmer.

ExtLib is not directly related to OCaml authors (INRIA) although this
library can be seen as a proposal for inclusion in the official
distribution.

This package contains files needed to develop OCaml programs using
this library.

%description devel -l pl.UTF-8
ExtLib to projekt, którego celem jest dostarczenie kompletnej lecz
małej biblioteki standardowej dla języka programowania OCaml. Celem
tej biblioteki jest dodanie nowych funkcji do modułów biblioteki
standardowej OCamla, zmodyfikowanie niektórych funkcji w celu
uzyskania lepszej wydajności lub bezpieczeństwa, a także dodanie
nowych modułów, które powinny być przydatne dla przeciętnego
programisty OCamla.

ExtLib nie jest bezpośrednio związany z autorami OCamla (INRIA), ale
tę bibliotekę można traktować jako propozycję do włączenia do
oficjalnej dystrybucji.

Ten pakiet zawiera pliki potrzebne do tworzenia programów w OCamlu z
użyciem tej biblioteki.

%prep
%setup -q -n %{pkgname}-%{version}
%patch0 -p1

%build
%{__make} -C src all %{?with_ocaml_opt:opt cmxs} \
       CC="%{__cc} %{rpmcflags} -fPIC"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/ocaml

OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml %{__make} install

%{__rm} $RPM_BUILD_ROOT%{_libdir}/ocaml/extlib/*.mli

%clean
rm -rf $RPM_BUILD_ROOT

%files devel
%defattr(644,root,root,755)
%doc LICENSE src/*.mli README.md
%dir %{_libdir}/ocaml/extlib
%{_libdir}/ocaml/extlib/META
%{_libdir}/ocaml/extlib/*.cm[ix]
%{_libdir}/ocaml/extlib/*.cma
%{_libdir}/ocaml/extlib/*.cmt
%{_libdir}/ocaml/extlib/*.cmti
%if %{with ocaml_opt}
%{_libdir}/ocaml/extlib/*.a
%{_libdir}/ocaml/extlib/*.cmxa
%{_libdir}/ocaml/extlib/*.cmxs
%endif
%changelog
* Sat Mar 27 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-extlib.git;a=log;h=master

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 6de93c0
- fix install
- rel 3

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 9d1b039
- update META file locations
- rel 2

* Thu Mar 25 2021 Jan Rękorajski <baggins@pld-linux.org> 33af9cb
- and fix opt build

* Thu Mar 25 2021 Jan Rękorajski <baggins@pld-linux.org> bfe1b3f
- fix non-opt build

* Thu Mar 25 2021 Jan Rękorajski <baggins@pld-linux.org> 92945d9
- up to 1.7.8

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 08d31e1
- rebuild with ocaml 4.04.1
- release 5 (by relup.sh)

* Fri Mar 18 2016 Jan Rękorajski <baggins@pld-linux.org> 3f5cab8
- release 4 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 08a6324
- fix files

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> bf0528c
- add ocaml_opt_bcond
- rel 3

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> 14141be
- rebuild with ocaml 4.02
- release 2 (by relup.sh)

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> 4bb906f
- up to 1.5.4

* Mon Jul 18 2011 Jan Rękorajski <baggins@pld-linux.org> 12b5b3f
- rel 3

* Sat Apr 18 2009 areq <areq@pld-linux.org> 67dd32b
- make -j1

* Sat Apr 18 2009 areq <areq@pld-linux.org> 551e1b4
- 1.5.1

* Thu Jul 10 2008 Marcin Banasiak <marcin.banasiak@gmail.com> 219eaa1
- release 4

* Mon Feb 04 2008 Elan Ruusamäe <glen@pld-linux.org> 5f4303d
- rel 3

* Thu Jan 31 2008 Elan Ruusamäe <glen@pld-linux.org> 9f8eb72
- rel 2

* Tue Nov 27 2007 Jan Rękorajski <baggins@pld-linux.org> 327c67e
- up to 1.5

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> a12496f
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 39a74cf
- converted to UTF-8

